-- Generated by scripts/GenerateShaders.elm, please do not edit by hand


module Scene3d.OptimizedShaders exposing
    ( colorTextureFragment
    , constantFragment
    , constantPointFragment
    , emissiveFragment
    , emissivePointFragment
    , emissiveTextureFragment
    , lambertianFragment
    , lambertianTextureFragment
    , normalMappedVertex
    , physicalFragment
    , physicalTexturesFragment
    , plainQuadVertex
    , plainVertex
    , pointVertex
    , quadShadowVertex
    , shadowFragment
    , shadowVertex
    , smoothQuadVertex
    , sphereShadowVertex
    , texturedQuadVertex
    , texturedVertex
    , uniformVertex
    , unlitQuadVertex
    , unlitVertex
    )

import Math.Matrix4 as Matrix4 exposing (Mat4)
import Math.Vector2 as Vector2 exposing (Vec2)
import Math.Vector3 as Vector3 exposing (Vec3)
import Math.Vector4 as Vector4 exposing (Vec4)
import WebGL
import WebGL.Texture exposing (Texture)


plainVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        {}
plainVertex =
    [glsl|
        precision mediump float;attribute vec3 position;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;void main(){vec4 a;a.w=1.0;a.xyz=(modelScale.xyz*position);gl_Position=(projectionMatrix*(viewMatrix*(modelMatrix*a)));}
    |]


unlitVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
            , uv : Vec2
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        { interpolatedUv : Vec2
        }
unlitVertex =
    [glsl|
        precision mediump float;attribute vec3 position;attribute vec2 uv;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;varying vec2 interpolatedUv;void main(){vec4 a;a.w=1.0;a.xyz=(modelScale.xyz*position);gl_Position=(projectionMatrix*(viewMatrix*(modelMatrix*a)));interpolatedUv=uv;}
    |]


uniformVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
            , normal : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        }
uniformVertex =
    [glsl|
        precision mediump float;attribute vec3 position;attribute vec3 normal;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;void main(){vec4 a;vec4 b;b.w=1.0;b.xyz=(modelScale.xyz*position);a=(modelMatrix*b);gl_Position=(projectionMatrix*(viewMatrix*a));interpolatedPosition=a.xyz;vec4 c;c.w=0.0;c.xyz=normal;interpolatedNormal=((modelMatrix*c).xyz*modelScale.w);}
    |]


texturedVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
            , normal : Vec3
            , uv : Vec2
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        , interpolatedUv : Vec2
        , interpolatedTangent : Vec3
        }
texturedVertex =
    [glsl|
        precision mediump float;attribute vec3 position;attribute vec3 normal;attribute vec2 uv;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;varying vec2 interpolatedUv;varying vec3 interpolatedTangent;void main(){vec4 a;vec4 b;b.w=1.0;b.xyz=(modelScale.xyz*position);a=(modelMatrix*b);gl_Position=(projectionMatrix*(viewMatrix*a));interpolatedPosition=a.xyz;vec4 c;c.w=0.0;c.xyz=normal;interpolatedNormal=((modelMatrix*c).xyz*modelScale.w);interpolatedUv=uv;interpolatedTangent=vec3(0.0,0.0,0.0);}
    |]


normalMappedVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
            , normal : Vec3
            , uv : Vec2
            , tangent : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        , interpolatedUv : Vec2
        , interpolatedTangent : Vec3
        }
normalMappedVertex =
    [glsl|
        precision mediump float;attribute vec3 position;attribute vec3 normal;attribute vec2 uv;attribute vec3 tangent;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;varying vec2 interpolatedUv;varying vec3 interpolatedTangent;void main(){vec4 a;vec4 b;b.w=1.0;b.xyz=(modelScale.xyz*position);a=(modelMatrix*b);gl_Position=(projectionMatrix*(viewMatrix*a));interpolatedPosition=a.xyz;vec4 c;c.w=0.0;c.xyz=normal;interpolatedNormal=((modelMatrix*c).xyz*modelScale.w);interpolatedUv=uv;vec4 d;d.w=0.0;d.xyz=tangent;interpolatedTangent=(modelMatrix*d).xyz;}
    |]


plainQuadVertex :
    WebGL.Shader
        { attributes
            | quadVertex : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , quadVertexPositions : Mat4
        }
        {}
plainQuadVertex =
    [glsl|
        precision mediump float;attribute vec3 quadVertex;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 quadVertexPositions;void main(){highp int a;a=int(quadVertex.z);vec3 b;if((a==0)){b=quadVertexPositions[0].xyz;}else{if((a==1)){b=quadVertexPositions[1].xyz;}else{if((a==2)){b=quadVertexPositions[2].xyz;}else{b=quadVertexPositions[3].xyz;}}}vec4 c;c.w=1.0;c.xyz=(modelScale.xyz*b);gl_Position=(projectionMatrix*(viewMatrix*(modelMatrix*c)));}
    |]


unlitQuadVertex :
    WebGL.Shader
        { attributes
            | quadVertex : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , quadVertexPositions : Mat4
        }
        { interpolatedUv : Vec2
        }
unlitQuadVertex =
    [glsl|
        precision mediump float;attribute vec3 quadVertex;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 quadVertexPositions;varying vec2 interpolatedUv;void main(){highp int a;a=int(quadVertex.z);vec3 b;if((a==0)){b=quadVertexPositions[0].xyz;}else{if((a==1)){b=quadVertexPositions[1].xyz;}else{if((a==2)){b=quadVertexPositions[2].xyz;}else{b=quadVertexPositions[3].xyz;}}}vec4 c;c.w=1.0;c.xyz=(modelScale.xyz*b);gl_Position=(projectionMatrix*(viewMatrix*(modelMatrix*c)));interpolatedUv=quadVertex.xy;}
    |]


smoothQuadVertex :
    WebGL.Shader
        { attributes
            | quadVertex : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , quadVertexPositions : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        }
smoothQuadVertex =
    [glsl|
        precision mediump float;attribute vec3 quadVertex;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 quadVertexPositions;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;void main(){highp int a;a=int(quadVertex.z);vec3 b;vec3 c;vec3 d;d=vec3(0.0,0.0,0.0);c=vec3(0.0,0.0,0.0);if((a==0)){c=quadVertexPositions[3].xyz;b=quadVertexPositions[0].xyz;d=quadVertexPositions[1].xyz;}else{if((a==1)){c=quadVertexPositions[0].xyz;b=quadVertexPositions[1].xyz;d=quadVertexPositions[2].xyz;}else{if((a==2)){c=quadVertexPositions[1].xyz;b=quadVertexPositions[2].xyz;d=quadVertexPositions[3].xyz;}else{c=quadVertexPositions[2].xyz;b=quadVertexPositions[3].xyz;d=quadVertexPositions[0].xyz;}}}vec3 e;e=(d-b);vec3 f;f=(c-b);vec4 g;vec4 h;h.w=1.0;h.xyz=(modelScale.xyz*b);g=(modelMatrix*h);gl_Position=(projectionMatrix*(viewMatrix*g));interpolatedPosition=g.xyz;vec4 i;i.w=0.0;i.xyz=normalize(((e.yzx*f.zxy)-(e.zxy*f.yzx)));interpolatedNormal=((modelMatrix*i).xyz*modelScale.w);}
    |]


texturedQuadVertex :
    WebGL.Shader
        { attributes
            | quadVertex : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , quadVertexPositions : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        , interpolatedUv : Vec2
        , interpolatedTangent : Vec3
        }
texturedQuadVertex =
    [glsl|
        precision mediump float;attribute vec3 quadVertex;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 quadVertexPositions;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;varying vec2 interpolatedUv;varying vec3 interpolatedTangent;void main(){highp int a;a=int(quadVertex.z);vec3 b;vec3 c;vec3 d;vec3 e;e=vec3(0.0,0.0,0.0);d=vec3(0.0,0.0,0.0);if((a==0)){d=quadVertexPositions[3].xyz;b=quadVertexPositions[0].xyz;e=quadVertexPositions[1].xyz;c=normalize((e-b));}else{if((a==1)){d=quadVertexPositions[0].xyz;b=quadVertexPositions[1].xyz;e=quadVertexPositions[2].xyz;c=normalize((b-d));}else{if((a==2)){d=quadVertexPositions[1].xyz;b=quadVertexPositions[2].xyz;e=quadVertexPositions[3].xyz;c=normalize((b-e));}else{d=quadVertexPositions[2].xyz;b=quadVertexPositions[3].xyz;e=quadVertexPositions[0].xyz;c=normalize((d-b));}}}vec3 f;f=(e-b);vec3 g;g=(d-b);vec4 h;vec4 i;i.w=1.0;i.xyz=(modelScale.xyz*b);h=(modelMatrix*i);gl_Position=(projectionMatrix*(viewMatrix*h));interpolatedPosition=h.xyz;vec4 j;j.w=0.0;j.xyz=normalize(((f.yzx*g.zxy)-(f.zxy*g.yzx)));interpolatedNormal=((modelMatrix*j).xyz*modelScale.w);interpolatedUv=quadVertex.xy;interpolatedTangent=c;}
    |]


pointVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , pointRadius : Float
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
        }
        {}
pointVertex =
    [glsl|
        precision mediump float;attribute vec3 position;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform float pointRadius;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 sceneProperties;void main(){vec4 a;a.w=1.0;a.xyz=(modelScale.xyz*position);gl_Position=(projectionMatrix*(viewMatrix*(modelMatrix*a)));gl_PointSize=(((2.0*pointRadius)*sceneProperties[3].x)+2.0);}
    |]


shadowVertex :
    WebGL.Shader
        { attributes
            | position : Vec3
            , normal : Vec3
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , shadowLight : Mat4
        }
        {}
shadowVertex =
    [glsl|
        precision mediump float;attribute vec3 position;attribute vec3 normal;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 shadowLight;void main(){vec3 a;vec3 b;vec4 c;vec4 d;d.w=1.0;d.xyz=(modelScale.xyz*position);c=(modelMatrix*d);vec4 e;e.w=0.0;e.xyz=normal;b=(modelMatrix*e).xyz;vec4 f;f=shadowLight[0];vec3 g;if((f.w==1.0)){g=f.xyz;}else{if((f.w==2.0)){g=normalize((f.xyz-c.xyz));}else{g=vec3(0.0,0.0,0.0);}}a=vec3(0.0,0.0,0.0);float h;h=dot(g,b);if((h<=0.0)){a=(-1e+09*g);}vec4 i;i.w=0.0;i.xyz=a;gl_Position=(projectionMatrix*(viewMatrix*(c+i)));}
    |]


quadShadowVertex :
    WebGL.Shader
        { attributes
            | quadShadowVertex : Vec2
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , shadowLight : Mat4
            , quadVertexPositions : Mat4
        }
        {}
quadShadowVertex =
    [glsl|
        precision mediump float;attribute vec2 quadShadowVertex;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 shadowLight;uniform mat4 quadVertexPositions;void main(){vec3 a;a=vec3(0.0,0.0,0.0);highp int b;b=int(quadShadowVertex.x);vec3 c;vec3 d;vec3 e;e=vec3(0.0,0.0,0.0);d=vec3(0.0,0.0,0.0);if((b==0)){d=quadVertexPositions[3].xyz;c=quadVertexPositions[0].xyz;e=quadVertexPositions[1].xyz;}else{if((b==1)){d=quadVertexPositions[0].xyz;c=quadVertexPositions[1].xyz;e=quadVertexPositions[2].xyz;}else{if((b==2)){d=quadVertexPositions[1].xyz;c=quadVertexPositions[2].xyz;e=quadVertexPositions[3].xyz;}else{d=quadVertexPositions[2].xyz;c=quadVertexPositions[3].xyz;e=quadVertexPositions[0].xyz;}}}vec3 f;f=(e-c);vec3 g;g=(d-c);a=(normalize(((f.yzx*g.zxy)-(f.zxy*g.yzx)))*quadShadowVertex.y);vec3 h;vec3 i;vec4 j;vec4 k;k.w=1.0;k.xyz=(modelScale.xyz*c);j=(modelMatrix*k);vec4 l;l.w=0.0;l.xyz=a;i=(modelMatrix*l).xyz;vec4 m;m=shadowLight[0];vec3 n;if((m.w==1.0)){n=m.xyz;}else{if((m.w==2.0)){n=normalize((m.xyz-j.xyz));}else{n=vec3(0.0,0.0,0.0);}}h=vec3(0.0,0.0,0.0);float o;o=dot(n,i);if((o<=0.0)){h=(-1e+09*n);}vec4 p;p.w=0.0;p.xyz=h;gl_Position=(projectionMatrix*(viewMatrix*(j+p)));}
    |]


sphereShadowVertex :
    WebGL.Shader
        { attributes
            | angle : Float
            , offsetScale : Float
        }
        { uniforms
            | modelScale : Vec4
            , modelMatrix : Mat4
            , viewMatrix : Mat4
            , projectionMatrix : Mat4
            , sceneProperties : Mat4
            , shadowLight : Mat4
        }
        {}
sphereShadowVertex =
    [glsl|
        precision mediump float;attribute float angle;attribute float offsetScale;uniform vec4 modelScale;uniform mat4 modelMatrix;uniform mat4 viewMatrix;uniform mat4 projectionMatrix;uniform mat4 shadowLight;void main(){float a;float b;vec4 c;c=(modelMatrix*vec4(0.0,0.0,0.0,1.0));vec4 d;d=shadowLight[0];vec3 e;if((d.w==1.0)){e=d.xyz;}else{if((d.w==2.0)){e=normalize((d.xyz-c.xyz));}else{e=vec3(0.0,0.0,0.0);}}vec3 f;float g;g=abs(e.x);float h;h=abs(e.y);float i;i=abs(e.z);if((g<=h)){if((g<=i)){float j;j=inversesqrt(dot(e.zy,e.zy));vec3 k;k.x=0.0;k.y=(-(e.z)*j);k.z=(e.y*j);f=k;}else{float l;l=inversesqrt(dot(e.xy,e.xy));vec3 m;m.z=0.0;m.x=(-(e.y)*l);m.y=(e.x*l);f=m;}}else{if((h<=i)){float n;n=inversesqrt(dot(e.xz,e.xz));vec3 o;o.y=0.0;o.x=(e.z*n);o.z=(-(e.x)*n);f=o;}else{float p;p=inversesqrt(dot(e.xy,e.xy));vec3 q;q.z=0.0;q.x=(-(e.y)*p);q.y=(e.x*p);f=q;}}vec3 r;r=((e.yzx*f.zxy)-(e.zxy*f.yzx));b=modelScale.x;a=0.0;if((d.w==2.0)){vec3 s;s=(d.xyz-c.xyz);float t;t=(modelScale.x*modelScale.x);a=(t/sqrt(dot(s,s)));b=sqrt((t-(a*a)));}vec3 u;u=(((c.xyz+(e*a))+((f*b)*cos(angle)))+((r*b)*sin(angle)));vec3 v;if((d.w==1.0)){v=d.xyz;}else{if((d.w==2.0)){v=normalize((d.xyz-u));}else{v=vec3(0.0,0.0,0.0);}}vec4 w;w.w=1.0;w.xyz=(u+((-1e+09*offsetScale)*v));gl_Position=(projectionMatrix*(viewMatrix*w));}
    |]


shadowFragment : WebGL.Shader {} uniforms {}
shadowFragment =
    [glsl|
        precision mediump float;void main(){gl_FragColor=vec4(0.0,0.0,0.0,1.0);}
    |]


constantFragment :
    WebGL.Shader {}
        { uniforms
            | constantColor : Vec3
        }
        {}
constantFragment =
    [glsl|
        precision mediump float;uniform vec3 constantColor;void main(){mediump vec4 a;a.w=1.0;a.xyz=constantColor;gl_FragColor=a;}
    |]


colorTextureFragment :
    WebGL.Shader {}
        { uniforms
            | colorTexture : Texture
        }
        { interpolatedUv : Vec2
        }
colorTextureFragment =
    [glsl|
        precision mediump float;uniform sampler2D colorTexture;varying vec2 interpolatedUv;void main(){lowp vec4 a;a=texture2D(colorTexture,interpolatedUv);gl_FragColor=a;}
    |]


constantPointFragment :
    WebGL.Shader {}
        { uniforms
            | constantColor : Vec3
            , pointRadius : Float
            , sceneProperties : Mat4
        }
        {}
constantPointFragment =
    [glsl|
        precision mediump float;uniform vec3 constantColor;uniform float pointRadius;uniform mat4 sceneProperties;void main(){float a;a=(pointRadius*sceneProperties[3].x);mediump float b;float c;c=(2.0*a);mediump float d;d=((c+2.0)*(gl_PointCoord.x-0.5));mediump float e;e=((c+2.0)*(gl_PointCoord.y-0.5));mediump float f;f=sqrt(((d*d)+(e*e)));float g;g=(a+1.0);if((f>g)){b=0.0;}else{if((f>a)){b=(g-f);}else{b=1.0;}}mediump vec4 h;h.xyz=constantColor;h.w=b;gl_FragColor=h;}
    |]


emissiveFragment :
    WebGL.Shader {}
        { uniforms
            | emissiveColor : Vec3
            , sceneProperties : Mat4
        }
        {}
emissiveFragment =
    [glsl|
        precision mediump float;uniform vec3 emissiveColor;uniform mat4 sceneProperties;void main(){vec3 a;a=sceneProperties[2].xyz;float b;b=(emissiveColor.x/a.x);float c;c=(emissiveColor.y/a.y);float d;d=(emissiveColor.z/a.z);float e;e=(((0.2126*b)+(0.7152*c))+(0.0722*d));float f;f=sceneProperties[2].w;float g;g=(((e*(1.0+(e/(f*f))))/(1.0+e))/e);float h;h=(b*g);mediump float i;if((h<=0.0031308)){i=(12.92*h);}else{i=((1.055*pow(h,0.4166667))-0.055);}float j;j=(c*g);mediump float k;if((j<=0.0031308)){k=(12.92*j);}else{k=((1.055*pow(j,0.4166667))-0.055);}float l;l=(d*g);mediump float m;if((l<=0.0031308)){m=(12.92*l);}else{m=((1.055*pow(l,0.4166667))-0.055);}mediump vec4 n;n.w=1.0;n.x=i;n.y=k;n.z=m;gl_FragColor=n;}
    |]


emissiveTextureFragment :
    WebGL.Shader {}
        { uniforms
            | colorTexture : Texture
            , backlight : Float
            , sceneProperties : Mat4
        }
        { interpolatedUv : Vec2
        }
emissiveTextureFragment =
    [glsl|
        precision mediump float;uniform sampler2D colorTexture;uniform float backlight;uniform mat4 sceneProperties;varying vec2 interpolatedUv;void main(){lowp vec3 a;a=texture2D(colorTexture,interpolatedUv).xyz;lowp float b;if((a.x<=0.04045)){b=clamp((a.x/12.92),0.0,1.0);}else{b=clamp(pow(((a.x+0.055)/1.055),2.4),0.0,1.0);}lowp float c;if((a.y<=0.04045)){c=clamp((a.y/12.92),0.0,1.0);}else{c=clamp(pow(((a.y+0.055)/1.055),2.4),0.0,1.0);}lowp float d;if((a.z<=0.04045)){d=clamp((a.z/12.92),0.0,1.0);}else{d=clamp(pow(((a.z+0.055)/1.055),2.4),0.0,1.0);}lowp vec3 e;e.x=b;e.y=c;e.z=d;lowp vec3 f;f=(e*backlight);vec3 g;g=sceneProperties[2].xyz;lowp float h;h=(f.x/g.x);lowp float i;i=(f.y/g.y);lowp float j;j=(f.z/g.z);lowp float k;k=(((0.2126*h)+(0.7152*i))+(0.0722*j));float l;l=sceneProperties[2].w;lowp float m;m=(((k*(1.0+(k/(l*l))))/(1.0+k))/k);lowp float n;n=(h*m);mediump float o;if((n<=0.0031308)){o=(12.92*n);}else{o=((1.055*pow(n,0.4166667))-0.055);}lowp float p;p=(i*m);mediump float q;if((p<=0.0031308)){q=(12.92*p);}else{q=((1.055*pow(p,0.4166667))-0.055);}lowp float r;r=(j*m);mediump float s;if((r<=0.0031308)){s=(12.92*r);}else{s=((1.055*pow(r,0.4166667))-0.055);}mediump vec4 t;t.w=1.0;t.x=o;t.y=q;t.z=s;gl_FragColor=t;}
    |]


emissivePointFragment :
    WebGL.Shader {}
        { uniforms
            | emissiveColor : Vec3
            , pointRadius : Float
            , sceneProperties : Mat4
        }
        {}
emissivePointFragment =
    [glsl|
        precision mediump float;uniform vec3 emissiveColor;uniform float pointRadius;uniform mat4 sceneProperties;void main(){vec3 a;a=sceneProperties[2].xyz;float b;b=(emissiveColor.x/a.x);float c;c=(emissiveColor.y/a.y);float d;d=(emissiveColor.z/a.z);float e;e=(((0.2126*b)+(0.7152*c))+(0.0722*d));float f;f=sceneProperties[2].w;float g;g=(((e*(1.0+(e/(f*f))))/(1.0+e))/e);float h;h=(b*g);float i;if((h<=0.0031308)){i=(12.92*h);}else{i=((1.055*pow(h,0.4166667))-0.055);}float j;j=(c*g);float k;if((j<=0.0031308)){k=(12.92*j);}else{k=((1.055*pow(j,0.4166667))-0.055);}float l;l=(d*g);float m;if((l<=0.0031308)){m=(12.92*l);}else{m=((1.055*pow(l,0.4166667))-0.055);}vec4 n;n.w=1.0;n.x=i;n.y=k;n.z=m;float o;o=(pointRadius*sceneProperties[3].x);mediump float p;float q;q=(2.0*o);mediump float r;r=((q+2.0)*(gl_PointCoord.x-0.5));mediump float s;s=((q+2.0)*(gl_PointCoord.y-0.5));mediump float t;t=sqrt(((r*r)+(s*s)));float u;u=(o+1.0);if((t>u)){p=0.0;}else{if((t>o)){p=(u-t);}else{p=1.0;}}mediump vec4 v;v.xyz=n.xyz;v.w=p;gl_FragColor=v;}
    |]


lambertianFragment :
    WebGL.Shader {}
        { uniforms
            | sceneProperties : Mat4
            , environmentalLighting : Mat4
            , lights12 : Mat4
            , lights34 : Mat4
            , lights56 : Mat4
            , lights78 : Mat4
            , materialColor : Vec3
            , viewMatrix : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        }
lambertianFragment =
    [glsl|
        precision mediump float;uniform mat4 sceneProperties;uniform mat4 environmentalLighting;uniform mat4 lights12;uniform mat4 lights34;uniform mat4 lights56;uniform mat4 lights78;uniform vec3 materialColor;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;void main(){lowp vec3 a;a=(normalize(interpolatedNormal)*((2.0*float(gl_FrontFacing))-1.0));lowp vec3 b;lowp vec3 c;float d;d=environmentalLighting[0].w;if((d==0.0)){c=vec3(0.0,0.0,0.0);}else{if((d==1.0)){lowp float e;e=((dot(a,environmentalLighting[0].xyz)+1.0)/2.0);c=(((environmentalLighting[1].xyz*e)+(environmentalLighting[2].xyz*(1.0-e)))*materialColor);}else{c=vec3(0.0,0.0,0.0);}}vec4 f;f=lights12[0];vec4 g;g=lights12[1];lowp vec3 h;if((f.w==0.0)){h=vec3(0.0,0.0,0.0);}else{vec3 i;vec3 j;if((f.w==1.0)){i=f.xyz;j=g.xyz;}else{if((f.w==2.0)){vec3 k;k=(f.xyz-interpolatedPosition);float l;l=sqrt(dot(k,k));i=(k/l);j=(g.xyz/((12.56637*l)*l));}}h=((j*clamp(dot(i,a),0.0,1.0))*(materialColor/3.141593));}vec4 m;m=lights12[2];vec4 n;n=lights12[3];lowp vec3 o;if((m.w==0.0)){o=vec3(0.0,0.0,0.0);}else{vec3 p;vec3 q;if((m.w==1.0)){p=m.xyz;q=n.xyz;}else{if((m.w==2.0)){vec3 r;r=(m.xyz-interpolatedPosition);float s;s=sqrt(dot(r,r));p=(r/s);q=(n.xyz/((12.56637*s)*s));}}o=((q*clamp(dot(p,a),0.0,1.0))*(materialColor/3.141593));}vec4 t;t=lights34[0];vec4 u;u=lights34[1];lowp vec3 v;if((t.w==0.0)){v=vec3(0.0,0.0,0.0);}else{vec3 w;vec3 x;if((t.w==1.0)){w=t.xyz;x=u.xyz;}else{if((t.w==2.0)){vec3 y;y=(t.xyz-interpolatedPosition);float z;z=sqrt(dot(y,y));w=(y/z);x=(u.xyz/((12.56637*z)*z));}}v=((x*clamp(dot(w,a),0.0,1.0))*(materialColor/3.141593));}vec4 A;A=lights34[2];vec4 B;B=lights34[3];lowp vec3 C;if((A.w==0.0)){C=vec3(0.0,0.0,0.0);}else{vec3 D;vec3 E;if((A.w==1.0)){D=A.xyz;E=B.xyz;}else{if((A.w==2.0)){vec3 F;F=(A.xyz-interpolatedPosition);float G;G=sqrt(dot(F,F));D=(F/G);E=(B.xyz/((12.56637*G)*G));}}C=((E*clamp(dot(D,a),0.0,1.0))*(materialColor/3.141593));}vec4 H;H=lights56[0];vec4 I;I=lights56[1];lowp vec3 J;if((H.w==0.0)){J=vec3(0.0,0.0,0.0);}else{vec3 K;vec3 L;if((H.w==1.0)){K=H.xyz;L=I.xyz;}else{if((H.w==2.0)){vec3 M;M=(H.xyz-interpolatedPosition);float N;N=sqrt(dot(M,M));K=(M/N);L=(I.xyz/((12.56637*N)*N));}}J=((L*clamp(dot(K,a),0.0,1.0))*(materialColor/3.141593));}vec4 O;O=lights56[2];vec4 P;P=lights56[3];lowp vec3 Q;if((O.w==0.0)){Q=vec3(0.0,0.0,0.0);}else{vec3 R;vec3 S;if((O.w==1.0)){R=O.xyz;S=P.xyz;}else{if((O.w==2.0)){vec3 T;T=(O.xyz-interpolatedPosition);float U;U=sqrt(dot(T,T));R=(T/U);S=(P.xyz/((12.56637*U)*U));}}Q=((S*clamp(dot(R,a),0.0,1.0))*(materialColor/3.141593));}vec4 V;V=lights78[0];vec4 W;W=lights78[1];lowp vec3 X;if((V.w==0.0)){X=vec3(0.0,0.0,0.0);}else{vec3 Y;vec3 Z;if((V.w==1.0)){Y=V.xyz;Z=W.xyz;}else{if((V.w==2.0)){vec3 ba;ba=(V.xyz-interpolatedPosition);float bb;bb=sqrt(dot(ba,ba));Y=(ba/bb);Z=(W.xyz/((12.56637*bb)*bb));}}X=((Z*clamp(dot(Y,a),0.0,1.0))*(materialColor/3.141593));}vec4 bc;bc=lights78[2];vec4 bd;bd=lights78[3];lowp vec3 be;if((bc.w==0.0)){be=vec3(0.0,0.0,0.0);}else{vec3 bf;vec3 bg;if((bc.w==1.0)){bf=bc.xyz;bg=bd.xyz;}else{if((bc.w==2.0)){vec3 bh;bh=(bc.xyz-interpolatedPosition);float bi;bi=sqrt(dot(bh,bh));bf=(bh/bi);bg=(bd.xyz/((12.56637*bi)*bi));}}be=((bg*clamp(dot(bf,a),0.0,1.0))*(materialColor/3.141593));}b=(((c+h)+(o+v))+((C+J)+((Q+X)+be)));vec3 bj;bj=sceneProperties[2].xyz;lowp float bk;bk=(b.x/bj.x);lowp float bl;bl=(b.y/bj.y);lowp float bm;bm=(b.z/bj.z);lowp float bn;bn=(((0.2126*bk)+(0.7152*bl))+(0.0722*bm));float bo;bo=sceneProperties[2].w;lowp float bp;bp=(((bn*(1.0+(bn/(bo*bo))))/(1.0+bn))/bn);lowp float bq;bq=(bk*bp);mediump float br;if((bq<=0.0031308)){br=(12.92*bq);}else{br=((1.055*pow(bq,0.4166667))-0.055);}lowp float bs;bs=(bl*bp);mediump float bt;if((bs<=0.0031308)){bt=(12.92*bs);}else{bt=((1.055*pow(bs,0.4166667))-0.055);}lowp float bu;bu=(bm*bp);mediump float bv;if((bu<=0.0031308)){bv=(12.92*bu);}else{bv=((1.055*pow(bu,0.4166667))-0.055);}mediump vec4 bw;bw.w=1.0;bw.x=br;bw.y=bt;bw.z=bv;gl_FragColor=bw;}
    |]


lambertianTextureFragment :
    WebGL.Shader {}
        { uniforms
            | sceneProperties : Mat4
            , environmentalLighting : Mat4
            , lights12 : Mat4
            , lights34 : Mat4
            , lights56 : Mat4
            , lights78 : Mat4
            , materialColorTexture : Texture
            , normalMapTexture : Texture
            , useNormalMap : Float
            , viewMatrix : Mat4
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        , interpolatedUv : Vec2
        , interpolatedTangent : Vec3
        }
lambertianTextureFragment =
    [glsl|
        precision mediump float;uniform mat4 sceneProperties;uniform mat4 environmentalLighting;uniform mat4 lights12;uniform mat4 lights34;uniform mat4 lights56;uniform mat4 lights78;uniform sampler2D materialColorTexture;uniform sampler2D normalMapTexture;uniform float useNormalMap;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;varying vec2 interpolatedUv;varying vec3 interpolatedTangent;void main(){lowp vec3 a;lowp vec3 b;b=((useNormalMap*texture2D(normalMapTexture,interpolatedUv).xyz)+((1.0-useNormalMap)*vec3(0.5,0.5,1.0)));lowp vec3 c;c.xy=-((vec2(2.0,2.0)*(b.xy-vec2(0.5,0.5))));c.z=(2.0*(b.z-0.5));lowp vec3 d;d=normalize(c);lowp float e;e=((2.0*float(gl_FrontFacing))-1.0);lowp vec3 f;f=(normalize(interpolatedNormal)*e);a=normalize((((d.x*interpolatedTangent)+(d.y*(((f.yzx*interpolatedTangent.zxy)-(f.zxy*interpolatedTangent.yzx))*e)))+(d.z*f)));lowp vec3 g;g=texture2D(materialColorTexture,interpolatedUv).xyz;lowp float h;if((g.x<=0.04045)){h=clamp((g.x/12.92),0.0,1.0);}else{h=clamp(pow(((g.x+0.055)/1.055),2.4),0.0,1.0);}lowp float i;if((g.y<=0.04045)){i=clamp((g.y/12.92),0.0,1.0);}else{i=clamp(pow(((g.y+0.055)/1.055),2.4),0.0,1.0);}lowp float j;if((g.z<=0.04045)){j=clamp((g.z/12.92),0.0,1.0);}else{j=clamp(pow(((g.z+0.055)/1.055),2.4),0.0,1.0);}lowp vec3 k;k.x=h;k.y=i;k.z=j;lowp vec3 l;lowp vec3 m;float n;n=environmentalLighting[0].w;if((n==0.0)){m=vec3(0.0,0.0,0.0);}else{if((n==1.0)){lowp float o;o=((dot(a,environmentalLighting[0].xyz)+1.0)/2.0);m=(((environmentalLighting[1].xyz*o)+(environmentalLighting[2].xyz*(1.0-o)))*k);}else{m=vec3(0.0,0.0,0.0);}}vec4 p;p=lights12[0];vec4 q;q=lights12[1];lowp vec3 r;if((p.w==0.0)){r=vec3(0.0,0.0,0.0);}else{vec3 s;vec3 t;if((p.w==1.0)){s=p.xyz;t=q.xyz;}else{if((p.w==2.0)){vec3 u;u=(p.xyz-interpolatedPosition);float v;v=sqrt(dot(u,u));s=(u/v);t=(q.xyz/((12.56637*v)*v));}}r=((t*clamp(dot(s,a),0.0,1.0))*(k/3.141593));}vec4 w;w=lights12[2];vec4 x;x=lights12[3];lowp vec3 y;if((w.w==0.0)){y=vec3(0.0,0.0,0.0);}else{vec3 z;vec3 A;if((w.w==1.0)){z=w.xyz;A=x.xyz;}else{if((w.w==2.0)){vec3 B;B=(w.xyz-interpolatedPosition);float C;C=sqrt(dot(B,B));z=(B/C);A=(x.xyz/((12.56637*C)*C));}}y=((A*clamp(dot(z,a),0.0,1.0))*(k/3.141593));}vec4 D;D=lights34[0];vec4 E;E=lights34[1];lowp vec3 F;if((D.w==0.0)){F=vec3(0.0,0.0,0.0);}else{vec3 G;vec3 H;if((D.w==1.0)){G=D.xyz;H=E.xyz;}else{if((D.w==2.0)){vec3 I;I=(D.xyz-interpolatedPosition);float J;J=sqrt(dot(I,I));G=(I/J);H=(E.xyz/((12.56637*J)*J));}}F=((H*clamp(dot(G,a),0.0,1.0))*(k/3.141593));}vec4 K;K=lights34[2];vec4 L;L=lights34[3];lowp vec3 M;if((K.w==0.0)){M=vec3(0.0,0.0,0.0);}else{vec3 N;vec3 O;if((K.w==1.0)){N=K.xyz;O=L.xyz;}else{if((K.w==2.0)){vec3 P;P=(K.xyz-interpolatedPosition);float Q;Q=sqrt(dot(P,P));N=(P/Q);O=(L.xyz/((12.56637*Q)*Q));}}M=((O*clamp(dot(N,a),0.0,1.0))*(k/3.141593));}vec4 R;R=lights56[0];vec4 S;S=lights56[1];lowp vec3 T;if((R.w==0.0)){T=vec3(0.0,0.0,0.0);}else{vec3 U;vec3 V;if((R.w==1.0)){U=R.xyz;V=S.xyz;}else{if((R.w==2.0)){vec3 W;W=(R.xyz-interpolatedPosition);float X;X=sqrt(dot(W,W));U=(W/X);V=(S.xyz/((12.56637*X)*X));}}T=((V*clamp(dot(U,a),0.0,1.0))*(k/3.141593));}vec4 Y;Y=lights56[2];vec4 Z;Z=lights56[3];lowp vec3 ba;if((Y.w==0.0)){ba=vec3(0.0,0.0,0.0);}else{vec3 bb;vec3 bc;if((Y.w==1.0)){bb=Y.xyz;bc=Z.xyz;}else{if((Y.w==2.0)){vec3 bd;bd=(Y.xyz-interpolatedPosition);float be;be=sqrt(dot(bd,bd));bb=(bd/be);bc=(Z.xyz/((12.56637*be)*be));}}ba=((bc*clamp(dot(bb,a),0.0,1.0))*(k/3.141593));}vec4 bf;bf=lights78[0];vec4 bg;bg=lights78[1];lowp vec3 bh;if((bf.w==0.0)){bh=vec3(0.0,0.0,0.0);}else{vec3 bi;vec3 bj;if((bf.w==1.0)){bi=bf.xyz;bj=bg.xyz;}else{if((bf.w==2.0)){vec3 bk;bk=(bf.xyz-interpolatedPosition);float bl;bl=sqrt(dot(bk,bk));bi=(bk/bl);bj=(bg.xyz/((12.56637*bl)*bl));}}bh=((bj*clamp(dot(bi,a),0.0,1.0))*(k/3.141593));}vec4 bm;bm=lights78[2];vec4 bn;bn=lights78[3];lowp vec3 bo;if((bm.w==0.0)){bo=vec3(0.0,0.0,0.0);}else{vec3 bp;vec3 bq;if((bm.w==1.0)){bp=bm.xyz;bq=bn.xyz;}else{if((bm.w==2.0)){vec3 br;br=(bm.xyz-interpolatedPosition);float bs;bs=sqrt(dot(br,br));bp=(br/bs);bq=(bn.xyz/((12.56637*bs)*bs));}}bo=((bq*clamp(dot(bp,a),0.0,1.0))*(k/3.141593));}l=(((m+r)+(y+F))+((M+T)+((ba+bh)+bo)));vec3 bt;bt=sceneProperties[2].xyz;lowp float bu;bu=(l.x/bt.x);lowp float bv;bv=(l.y/bt.y);lowp float bw;bw=(l.z/bt.z);lowp float bx;bx=(((0.2126*bu)+(0.7152*bv))+(0.0722*bw));float by;by=sceneProperties[2].w;lowp float bz;bz=(((bx*(1.0+(bx/(by*by))))/(1.0+bx))/bx);lowp float bA;bA=(bu*bz);mediump float bB;if((bA<=0.0031308)){bB=(12.92*bA);}else{bB=((1.055*pow(bA,0.4166667))-0.055);}lowp float bC;bC=(bv*bz);mediump float bD;if((bC<=0.0031308)){bD=(12.92*bC);}else{bD=((1.055*pow(bC,0.4166667))-0.055);}lowp float bE;bE=(bw*bz);mediump float bF;if((bE<=0.0031308)){bF=(12.92*bE);}else{bF=((1.055*pow(bE,0.4166667))-0.055);}mediump vec4 bG;bG.w=1.0;bG.x=bB;bG.y=bD;bG.z=bF;gl_FragColor=bG;}
    |]


physicalFragment :
    WebGL.Shader {}
        { uniforms
            | sceneProperties : Mat4
            , environmentalLighting : Mat4
            , viewMatrix : Mat4
            , lights12 : Mat4
            , lights34 : Mat4
            , lights56 : Mat4
            , lights78 : Mat4
            , baseColor : Vec3
            , roughness : Float
            , metallic : Float
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        }
physicalFragment =
    [glsl|
        precision mediump float;uniform mat4 sceneProperties;uniform mat4 environmentalLighting;uniform mat4 viewMatrix;uniform mat4 lights12;uniform mat4 lights34;uniform mat4 lights56;uniform mat4 lights78;uniform vec3 baseColor;uniform float roughness;uniform float metallic;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;void main(){lowp vec3 a;a=(normalize(interpolatedNormal)*((2.0*float(gl_FrontFacing))-1.0));vec3 b;float c;c=sceneProperties[1].w;if((c==0.0)){b=normalize((sceneProperties[1].xyz-interpolatedPosition));}else{b=sceneProperties[1].xyz;}lowp vec3 d;float e;e=(roughness*roughness);float f;f=(1.0-metallic);vec3 g;g=((f*0.96)*baseColor);vec3 h;h=(vec3((f*0.04))+(metallic*baseColor));lowp vec3 i;float j;j=environmentalLighting[0].w;float k;k=(e*e);if((j==0.0)){i=vec3(0.0,0.0,0.0);}else{if((j==1.0)){lowp vec3 l;lowp vec3 m;vec3 n;n=environmentalLighting[0].xyz;vec3 o;o=environmentalLighting[1].xyz;vec3 p;p=environmentalLighting[2].xyz;lowp vec3 q;q=((a.yzx*b.zxy)-(a.zxy*b.yzx));lowp float r;r=sqrt(dot(q,q));m=vec3(0.0,0.0,0.0);l=vec3(0.0,0.0,0.0);if((r>1e-06)){l=((1.0/(r))*q);m=((l.yzx*a.zxy)-(l.zxy*a.yzx));}else{vec3 s;s.x=viewMatrix[0].y;s.y=viewMatrix[1].y;s.z=viewMatrix[2].y;lowp vec3 t;t=normalize(((s.yzx*a.zxy)-(s.zxy*a.yzx)));m=t;l=((a.yzx*t.zxy)-(a.zxy*t.yzx));}lowp float u;u=dot(b,m);lowp float v;v=dot(b,a);lowp vec3 w;w.y=0.0;w.x=u;w.z=v;lowp vec3 x;x.x=dot(n,m);x.y=dot(n,l);x.z=dot(n,a);lowp vec3 y;y.y=0.0;y.x=(e*u);y.z=v;lowp vec3 z;z=normalize(y);lowp float A;A=(1.0-(0.5*(1.0+z.z)));lowp vec3 B;B=((A*((z.yzx*vec3(0.0,0.0,1.0))-(z.zxy*vec3(1.0,0.0,0.0))))+(sqrt(max(0.0,(1.0-(A*A))))*z));lowp vec3 C;C.xy=(vec2(e)*B.xy);C.z=max(0.0,B.z);lowp vec3 D;D=normalize(C);lowp vec3 E;E=(((2.0*dot(w,D))*D)-w);lowp vec3 F;lowp float G;G=((dot(E,x)+1.0)/2.0);F=((o*G)+(p*(1.0-G)));lowp float H;H=clamp(dot(w,D),0.0,1.0);lowp vec3 I;I=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*H)-6.98316)*H))));lowp float J;J=(2.0*E.z);lowp float K;K=(E.z+sqrt((k+(((1.0-k)*E.z)*E.z))));lowp float L;if((K==0.0)){L=0.0;}else{L=(J/K);}lowp float M;M=((x.z+1.0)/2.0);i=((F*(I*L))+(((o*M)+(p*(1.0-M)))*g));}else{i=vec3(0.0,0.0,0.0);}}lowp float N;N=clamp(dot(a,b),0.0,1.0);vec4 O;O=lights12[0];vec4 P;P=lights12[1];lowp vec3 Q;if((O.w==0.0)){Q=vec3(0.0,0.0,0.0);}else{vec3 R;vec3 S;if((O.w==1.0)){R=O.xyz;S=P.xyz;}else{if((O.w==2.0)){vec3 T;T=(O.xyz-interpolatedPosition);float U;U=sqrt(dot(T,T));R=(T/U);S=(P.xyz/((12.56637*U)*U));}}lowp float V;V=clamp(dot(a,R),0.0,1.0);vec3 W;lowp float X;float Y;vec3 Z;Z=normalize((b+R));Y=clamp(dot(b,Z),0.0,1.0);lowp vec3 ba;ba=((a.yzx*Z.zxy)-(a.zxy*Z.yzx));lowp float bb;bb=(clamp(dot(a,Z),0.0,1.0)*e);lowp float bc;bc=(e/(dot(ba,ba)+(bb*bb)));X=min(((bc*bc)*0.3183099),65504.0);float bd;bd=(e*e);lowp float be;be=(2.0*N);lowp float bf;bf=(N+sqrt((bd+(((1.0-bd)*N)*N))));lowp float bg;if((bf==0.0)){bg=0.0;}else{bg=(be/bf);}lowp float bh;bh=(2.0*V);lowp float bi;bi=(V+sqrt((bd+(((1.0-bd)*V)*V))));lowp float bj;if((bi==0.0)){bj=0.0;}else{bj=(bh/bi);}W=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*Y)-6.98316)*Y))));lowp float bk;bk=(X*(bg*bj));lowp float bl;bl=((4.0*V)*N);lowp float bm;if((bl==0.0)){bm=0.0;}else{bm=(bk/bl);}Q=((S*V)*((g/3.141593)+(bm*W)));}vec4 bn;bn=lights12[2];vec4 bo;bo=lights12[3];lowp vec3 bp;if((bn.w==0.0)){bp=vec3(0.0,0.0,0.0);}else{vec3 bq;vec3 br;if((bn.w==1.0)){bq=bn.xyz;br=bo.xyz;}else{if((bn.w==2.0)){vec3 bs;bs=(bn.xyz-interpolatedPosition);float bt;bt=sqrt(dot(bs,bs));bq=(bs/bt);br=(bo.xyz/((12.56637*bt)*bt));}}lowp float bu;bu=clamp(dot(a,bq),0.0,1.0);vec3 bv;lowp float bw;float bx;vec3 by;by=normalize((b+bq));bx=clamp(dot(b,by),0.0,1.0);lowp vec3 bz;bz=((a.yzx*by.zxy)-(a.zxy*by.yzx));lowp float bA;bA=(clamp(dot(a,by),0.0,1.0)*e);lowp float bB;bB=(e/(dot(bz,bz)+(bA*bA)));bw=min(((bB*bB)*0.3183099),65504.0);float bC;bC=(e*e);lowp float bD;bD=(2.0*N);lowp float bE;bE=(N+sqrt((bC+(((1.0-bC)*N)*N))));lowp float bF;if((bE==0.0)){bF=0.0;}else{bF=(bD/bE);}lowp float bG;bG=(2.0*bu);lowp float bH;bH=(bu+sqrt((bC+(((1.0-bC)*bu)*bu))));lowp float bI;if((bH==0.0)){bI=0.0;}else{bI=(bG/bH);}bv=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*bx)-6.98316)*bx))));lowp float bJ;bJ=(bw*(bF*bI));lowp float bK;bK=((4.0*bu)*N);lowp float bL;if((bK==0.0)){bL=0.0;}else{bL=(bJ/bK);}bp=((br*bu)*((g/3.141593)+(bL*bv)));}vec4 bM;bM=lights34[0];vec4 bN;bN=lights34[1];lowp vec3 bO;if((bM.w==0.0)){bO=vec3(0.0,0.0,0.0);}else{vec3 bP;vec3 bQ;if((bM.w==1.0)){bP=bM.xyz;bQ=bN.xyz;}else{if((bM.w==2.0)){vec3 bR;bR=(bM.xyz-interpolatedPosition);float bS;bS=sqrt(dot(bR,bR));bP=(bR/bS);bQ=(bN.xyz/((12.56637*bS)*bS));}}lowp float bT;bT=clamp(dot(a,bP),0.0,1.0);vec3 bU;lowp float bV;float bW;vec3 bX;bX=normalize((b+bP));bW=clamp(dot(b,bX),0.0,1.0);lowp vec3 bY;bY=((a.yzx*bX.zxy)-(a.zxy*bX.yzx));lowp float bZ;bZ=(clamp(dot(a,bX),0.0,1.0)*e);lowp float ca;ca=(e/(dot(bY,bY)+(bZ*bZ)));bV=min(((ca*ca)*0.3183099),65504.0);float cb;cb=(e*e);lowp float cc;cc=(2.0*N);lowp float cd;cd=(N+sqrt((cb+(((1.0-cb)*N)*N))));lowp float ce;if((cd==0.0)){ce=0.0;}else{ce=(cc/cd);}lowp float cf;cf=(2.0*bT);lowp float cg;cg=(bT+sqrt((cb+(((1.0-cb)*bT)*bT))));lowp float ch;if((cg==0.0)){ch=0.0;}else{ch=(cf/cg);}bU=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*bW)-6.98316)*bW))));lowp float ci;ci=(bV*(ce*ch));lowp float cj;cj=((4.0*bT)*N);lowp float ck;if((cj==0.0)){ck=0.0;}else{ck=(ci/cj);}bO=((bQ*bT)*((g/3.141593)+(ck*bU)));}vec4 cl;cl=lights34[2];vec4 cm;cm=lights34[3];lowp vec3 cn;if((cl.w==0.0)){cn=vec3(0.0,0.0,0.0);}else{vec3 co;vec3 cp;if((cl.w==1.0)){co=cl.xyz;cp=cm.xyz;}else{if((cl.w==2.0)){vec3 cq;cq=(cl.xyz-interpolatedPosition);float cr;cr=sqrt(dot(cq,cq));co=(cq/cr);cp=(cm.xyz/((12.56637*cr)*cr));}}lowp float cs;cs=clamp(dot(a,co),0.0,1.0);vec3 ct;lowp float cu;float cv;vec3 cw;cw=normalize((b+co));cv=clamp(dot(b,cw),0.0,1.0);lowp vec3 cx;cx=((a.yzx*cw.zxy)-(a.zxy*cw.yzx));lowp float cy;cy=(clamp(dot(a,cw),0.0,1.0)*e);lowp float cz;cz=(e/(dot(cx,cx)+(cy*cy)));cu=min(((cz*cz)*0.3183099),65504.0);float cA;cA=(e*e);lowp float cB;cB=(2.0*N);lowp float cC;cC=(N+sqrt((cA+(((1.0-cA)*N)*N))));lowp float cD;if((cC==0.0)){cD=0.0;}else{cD=(cB/cC);}lowp float cE;cE=(2.0*cs);lowp float cF;cF=(cs+sqrt((cA+(((1.0-cA)*cs)*cs))));lowp float cG;if((cF==0.0)){cG=0.0;}else{cG=(cE/cF);}ct=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*cv)-6.98316)*cv))));lowp float cH;cH=(cu*(cD*cG));lowp float cI;cI=((4.0*cs)*N);lowp float cJ;if((cI==0.0)){cJ=0.0;}else{cJ=(cH/cI);}cn=((cp*cs)*((g/3.141593)+(cJ*ct)));}vec4 cK;cK=lights56[0];vec4 cL;cL=lights56[1];lowp vec3 cM;if((cK.w==0.0)){cM=vec3(0.0,0.0,0.0);}else{vec3 cN;vec3 cO;if((cK.w==1.0)){cN=cK.xyz;cO=cL.xyz;}else{if((cK.w==2.0)){vec3 cP;cP=(cK.xyz-interpolatedPosition);float cQ;cQ=sqrt(dot(cP,cP));cN=(cP/cQ);cO=(cL.xyz/((12.56637*cQ)*cQ));}}lowp float cR;cR=clamp(dot(a,cN),0.0,1.0);vec3 cS;lowp float cT;float cU;vec3 cV;cV=normalize((b+cN));cU=clamp(dot(b,cV),0.0,1.0);lowp vec3 cW;cW=((a.yzx*cV.zxy)-(a.zxy*cV.yzx));lowp float cX;cX=(clamp(dot(a,cV),0.0,1.0)*e);lowp float cY;cY=(e/(dot(cW,cW)+(cX*cX)));cT=min(((cY*cY)*0.3183099),65504.0);float cZ;cZ=(e*e);lowp float da;da=(2.0*N);lowp float db;db=(N+sqrt((cZ+(((1.0-cZ)*N)*N))));lowp float dc;if((db==0.0)){dc=0.0;}else{dc=(da/db);}lowp float dd;dd=(2.0*cR);lowp float de;de=(cR+sqrt((cZ+(((1.0-cZ)*cR)*cR))));lowp float df;if((de==0.0)){df=0.0;}else{df=(dd/de);}cS=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*cU)-6.98316)*cU))));lowp float dg;dg=(cT*(dc*df));lowp float dh;dh=((4.0*cR)*N);lowp float di;if((dh==0.0)){di=0.0;}else{di=(dg/dh);}cM=((cO*cR)*((g/3.141593)+(di*cS)));}vec4 dj;dj=lights56[2];vec4 dk;dk=lights56[3];lowp vec3 dl;if((dj.w==0.0)){dl=vec3(0.0,0.0,0.0);}else{vec3 dm;vec3 dn;if((dj.w==1.0)){dm=dj.xyz;dn=dk.xyz;}else{if((dj.w==2.0)){vec3 do_;do_=(dj.xyz-interpolatedPosition);float dp;dp=sqrt(dot(do_,do_));dm=(do_/dp);dn=(dk.xyz/((12.56637*dp)*dp));}}lowp float dq;dq=clamp(dot(a,dm),0.0,1.0);vec3 dr;lowp float ds;float dt;vec3 du;du=normalize((b+dm));dt=clamp(dot(b,du),0.0,1.0);lowp vec3 dv;dv=((a.yzx*du.zxy)-(a.zxy*du.yzx));lowp float dw;dw=(clamp(dot(a,du),0.0,1.0)*e);lowp float dx;dx=(e/(dot(dv,dv)+(dw*dw)));ds=min(((dx*dx)*0.3183099),65504.0);float dy;dy=(e*e);lowp float dz;dz=(2.0*N);lowp float dA;dA=(N+sqrt((dy+(((1.0-dy)*N)*N))));lowp float dB;if((dA==0.0)){dB=0.0;}else{dB=(dz/dA);}lowp float dC;dC=(2.0*dq);lowp float dD;dD=(dq+sqrt((dy+(((1.0-dy)*dq)*dq))));lowp float dE;if((dD==0.0)){dE=0.0;}else{dE=(dC/dD);}dr=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*dt)-6.98316)*dt))));lowp float dF;dF=(ds*(dB*dE));lowp float dG;dG=((4.0*dq)*N);lowp float dH;if((dG==0.0)){dH=0.0;}else{dH=(dF/dG);}dl=((dn*dq)*((g/3.141593)+(dH*dr)));}vec4 dI;dI=lights78[0];vec4 dJ;dJ=lights78[1];lowp vec3 dK;if((dI.w==0.0)){dK=vec3(0.0,0.0,0.0);}else{vec3 dL;vec3 dM;if((dI.w==1.0)){dL=dI.xyz;dM=dJ.xyz;}else{if((dI.w==2.0)){vec3 dN;dN=(dI.xyz-interpolatedPosition);float dO;dO=sqrt(dot(dN,dN));dL=(dN/dO);dM=(dJ.xyz/((12.56637*dO)*dO));}}lowp float dP;dP=clamp(dot(a,dL),0.0,1.0);vec3 dQ;lowp float dR;float dS;vec3 dT;dT=normalize((b+dL));dS=clamp(dot(b,dT),0.0,1.0);lowp vec3 dU;dU=((a.yzx*dT.zxy)-(a.zxy*dT.yzx));lowp float dV;dV=(clamp(dot(a,dT),0.0,1.0)*e);lowp float dW;dW=(e/(dot(dU,dU)+(dV*dV)));dR=min(((dW*dW)*0.3183099),65504.0);float dX;dX=(e*e);lowp float dY;dY=(2.0*N);lowp float dZ;dZ=(N+sqrt((dX+(((1.0-dX)*N)*N))));lowp float ea;if((dZ==0.0)){ea=0.0;}else{ea=(dY/dZ);}lowp float eb;eb=(2.0*dP);lowp float ec;ec=(dP+sqrt((dX+(((1.0-dX)*dP)*dP))));lowp float ed;if((ec==0.0)){ed=0.0;}else{ed=(eb/ec);}dQ=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*dS)-6.98316)*dS))));lowp float ee;ee=(dR*(ea*ed));lowp float ef;ef=((4.0*dP)*N);lowp float eg;if((ef==0.0)){eg=0.0;}else{eg=(ee/ef);}dK=((dM*dP)*((g/3.141593)+(eg*dQ)));}vec4 eh;eh=lights78[2];vec4 ei;ei=lights78[3];lowp vec3 ej;if((eh.w==0.0)){ej=vec3(0.0,0.0,0.0);}else{vec3 ek;vec3 el;if((eh.w==1.0)){ek=eh.xyz;el=ei.xyz;}else{if((eh.w==2.0)){vec3 em;em=(eh.xyz-interpolatedPosition);float en;en=sqrt(dot(em,em));ek=(em/en);el=(ei.xyz/((12.56637*en)*en));}}lowp float eo;eo=clamp(dot(a,ek),0.0,1.0);vec3 ep;lowp float eq;float er;vec3 es;es=normalize((b+ek));er=clamp(dot(b,es),0.0,1.0);lowp vec3 et;et=((a.yzx*es.zxy)-(a.zxy*es.yzx));lowp float eu;eu=(clamp(dot(a,es),0.0,1.0)*e);lowp float ev;ev=(e/(dot(et,et)+(eu*eu)));eq=min(((ev*ev)*0.3183099),65504.0);float ew;ew=(e*e);lowp float ex;ex=(2.0*N);lowp float ey;ey=(N+sqrt((ew+(((1.0-ew)*N)*N))));lowp float ez;if((ey==0.0)){ez=0.0;}else{ez=(ex/ey);}lowp float eA;eA=(2.0*eo);lowp float eB;eB=(eo+sqrt((ew+(((1.0-ew)*eo)*eo))));lowp float eC;if((eB==0.0)){eC=0.0;}else{eC=(eA/eB);}ep=(h+((vec3(1.0,1.0,1.0)-h)*exp2((((-5.55473*er)-6.98316)*er))));lowp float eD;eD=(eq*(ez*eC));lowp float eE;eE=((4.0*eo)*N);lowp float eF;if((eE==0.0)){eF=0.0;}else{eF=(eD/eE);}ej=((el*eo)*((g/3.141593)+(eF*ep)));}d=(((i+Q)+(bp+bO))+((cn+cM)+((dl+dK)+ej)));vec3 eG;eG=sceneProperties[2].xyz;lowp float eH;eH=(d.x/eG.x);lowp float eI;eI=(d.y/eG.y);lowp float eJ;eJ=(d.z/eG.z);lowp float eK;eK=(((0.2126*eH)+(0.7152*eI))+(0.0722*eJ));float eL;eL=sceneProperties[2].w;lowp float eM;eM=(((eK*(1.0+(eK/(eL*eL))))/(1.0+eK))/eK);lowp float eN;eN=(eH*eM);mediump float eO;if((eN<=0.0031308)){eO=(12.92*eN);}else{eO=((1.055*pow(eN,0.4166667))-0.055);}lowp float eP;eP=(eI*eM);mediump float eQ;if((eP<=0.0031308)){eQ=(12.92*eP);}else{eQ=((1.055*pow(eP,0.4166667))-0.055);}lowp float eR;eR=(eJ*eM);mediump float eS;if((eR<=0.0031308)){eS=(12.92*eR);}else{eS=((1.055*pow(eR,0.4166667))-0.055);}mediump vec4 eT;eT.w=1.0;eT.x=eO;eT.y=eQ;eT.z=eS;gl_FragColor=eT;}
    |]


physicalTexturesFragment :
    WebGL.Shader {}
        { uniforms
            | sceneProperties : Mat4
            , environmentalLighting : Mat4
            , viewMatrix : Mat4
            , lights12 : Mat4
            , lights34 : Mat4
            , lights56 : Mat4
            , lights78 : Mat4
            , baseColorTexture : Texture
            , constantBaseColor : Vec4
            , roughnessTexture : Texture
            , roughnessChannel : Vec4
            , metallicTexture : Texture
            , metallicChannel : Vec4
            , normalMapTexture : Texture
            , useNormalMap : Float
        }
        { interpolatedPosition : Vec3
        , interpolatedNormal : Vec3
        , interpolatedUv : Vec2
        , interpolatedTangent : Vec3
        }
physicalTexturesFragment =
    [glsl|
        precision mediump float;uniform mat4 sceneProperties;uniform mat4 environmentalLighting;uniform mat4 viewMatrix;uniform mat4 lights12;uniform mat4 lights34;uniform mat4 lights56;uniform mat4 lights78;uniform sampler2D baseColorTexture;uniform vec4 constantBaseColor;uniform sampler2D roughnessTexture;uniform vec4 roughnessChannel;uniform sampler2D metallicTexture;uniform vec4 metallicChannel;uniform sampler2D normalMapTexture;uniform float useNormalMap;varying vec3 interpolatedPosition;varying vec3 interpolatedNormal;varying vec2 interpolatedUv;varying vec3 interpolatedTangent;void main(){lowp vec3 a;lowp float b;lowp float c;lowp vec3 d;lowp vec3 e;e=texture2D(baseColorTexture,interpolatedUv).xyz;lowp float f;if((e.x<=0.04045)){f=clamp((e.x/12.92),0.0,1.0);}else{f=clamp(pow(((e.x+0.055)/1.055),2.4),0.0,1.0);}lowp float g;if((e.y<=0.04045)){g=clamp((e.y/12.92),0.0,1.0);}else{g=clamp(pow(((e.y+0.055)/1.055),2.4),0.0,1.0);}lowp float h;if((e.z<=0.04045)){h=clamp((e.z/12.92),0.0,1.0);}else{h=clamp(pow(((e.z+0.055)/1.055),2.4),0.0,1.0);}lowp vec3 i;i.x=f;i.y=g;i.z=h;d=((i*(1.0-constantBaseColor.w))+(constantBaseColor.xyz*constantBaseColor.w));float j;j=float((roughnessChannel.xyz==vec3(0.0,0.0,0.0)));c=clamp(((dot(texture2D(roughnessTexture,interpolatedUv).xyz,roughnessChannel.xyz)*(1.0-j))+(roughnessChannel.w*j)),0.0,1.0);float k;k=float((metallicChannel.xyz==vec3(0.0,0.0,0.0)));b=clamp(((dot(texture2D(metallicTexture,interpolatedUv).xyz,metallicChannel.xyz)*(1.0-k))+(metallicChannel.w*k)),0.0,1.0);lowp vec3 l;l=((useNormalMap*texture2D(normalMapTexture,interpolatedUv).xyz)+((1.0-useNormalMap)*vec3(0.5,0.5,1.0)));lowp vec3 m;m.xy=-((vec2(2.0,2.0)*(l.xy-vec2(0.5,0.5))));m.z=(2.0*(l.z-0.5));lowp vec3 n;n=normalize(m);lowp float o;o=((2.0*float(gl_FrontFacing))-1.0);lowp vec3 p;p=(normalize(interpolatedNormal)*o);a=normalize((((n.x*interpolatedTangent)+(n.y*(((p.yzx*interpolatedTangent.zxy)-(p.zxy*interpolatedTangent.yzx))*o)))+(n.z*p)));vec3 q;float r;r=sceneProperties[1].w;if((r==0.0)){q=normalize((sceneProperties[1].xyz-interpolatedPosition));}else{q=sceneProperties[1].xyz;}lowp vec3 s;lowp float t;t=(c*c);lowp float u;u=(1.0-b);lowp vec3 v;v=((u*0.96)*d);lowp vec3 w;w=(vec3((u*0.04))+(b*d));lowp vec3 x;float y;y=environmentalLighting[0].w;lowp float z;z=(t*t);if((y==0.0)){x=vec3(0.0,0.0,0.0);}else{if((y==1.0)){lowp vec3 A;lowp vec3 B;vec3 C;C=environmentalLighting[0].xyz;vec3 D;D=environmentalLighting[1].xyz;vec3 E;E=environmentalLighting[2].xyz;lowp vec3 F;F=((a.yzx*q.zxy)-(a.zxy*q.yzx));lowp float G;G=sqrt(dot(F,F));B=vec3(0.0,0.0,0.0);A=vec3(0.0,0.0,0.0);if((G>1e-06)){A=((1.0/(G))*F);B=((A.yzx*a.zxy)-(A.zxy*a.yzx));}else{vec3 H;H.x=viewMatrix[0].y;H.y=viewMatrix[1].y;H.z=viewMatrix[2].y;lowp vec3 I;I=normalize(((H.yzx*a.zxy)-(H.zxy*a.yzx)));B=I;A=((a.yzx*I.zxy)-(a.zxy*I.yzx));}lowp float J;J=dot(q,B);lowp float K;K=dot(q,a);lowp vec3 L;L.y=0.0;L.x=J;L.z=K;lowp vec3 M;M.x=dot(C,B);M.y=dot(C,A);M.z=dot(C,a);lowp vec3 N;N.y=0.0;N.x=(t*J);N.z=K;lowp vec3 O;O=normalize(N);lowp float P;P=(1.0-(0.5*(1.0+O.z)));lowp vec3 Q;Q=((P*((O.yzx*vec3(0.0,0.0,1.0))-(O.zxy*vec3(1.0,0.0,0.0))))+(sqrt(max(0.0,(1.0-(P*P))))*O));lowp vec3 R;R.xy=(vec2(t)*Q.xy);R.z=max(0.0,Q.z);lowp vec3 S;S=normalize(R);lowp vec3 T;T=(((2.0*dot(L,S))*S)-L);lowp vec3 U;lowp float V;V=((dot(T,M)+1.0)/2.0);U=((D*V)+(E*(1.0-V)));lowp float W;W=clamp(dot(L,S),0.0,1.0);lowp vec3 X;X=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*W)-6.98316)*W))));lowp float Y;Y=(2.0*T.z);lowp float Z;Z=(T.z+sqrt((z+(((1.0-z)*T.z)*T.z))));lowp float ba;if((Z==0.0)){ba=0.0;}else{ba=(Y/Z);}lowp float bb;bb=((M.z+1.0)/2.0);x=((U*(X*ba))+(((D*bb)+(E*(1.0-bb)))*v));}else{x=vec3(0.0,0.0,0.0);}}lowp float bc;bc=clamp(dot(a,q),0.0,1.0);vec4 bd;bd=lights12[0];vec4 be;be=lights12[1];lowp vec3 bf;if((bd.w==0.0)){bf=vec3(0.0,0.0,0.0);}else{vec3 bg;vec3 bh;if((bd.w==1.0)){bg=bd.xyz;bh=be.xyz;}else{if((bd.w==2.0)){vec3 bi;bi=(bd.xyz-interpolatedPosition);float bj;bj=sqrt(dot(bi,bi));bg=(bi/bj);bh=(be.xyz/((12.56637*bj)*bj));}}lowp float bk;bk=clamp(dot(a,bg),0.0,1.0);lowp vec3 bl;lowp float bm;float bn;vec3 bo;bo=normalize((q+bg));bn=clamp(dot(q,bo),0.0,1.0);lowp vec3 bp;bp=((a.yzx*bo.zxy)-(a.zxy*bo.yzx));lowp float bq;bq=(clamp(dot(a,bo),0.0,1.0)*t);lowp float br;br=(t/(dot(bp,bp)+(bq*bq)));bm=min(((br*br)*0.3183099),65504.0);lowp float bs;bs=(t*t);lowp float bt;bt=(2.0*bc);lowp float bu;bu=(bc+sqrt((bs+(((1.0-bs)*bc)*bc))));lowp float bv;if((bu==0.0)){bv=0.0;}else{bv=(bt/bu);}lowp float bw;bw=(2.0*bk);lowp float bx;bx=(bk+sqrt((bs+(((1.0-bs)*bk)*bk))));lowp float by;if((bx==0.0)){by=0.0;}else{by=(bw/bx);}bl=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*bn)-6.98316)*bn))));lowp float bz;bz=(bm*(bv*by));lowp float bA;bA=((4.0*bk)*bc);lowp float bB;if((bA==0.0)){bB=0.0;}else{bB=(bz/bA);}bf=((bh*bk)*((v/3.141593)+(bB*bl)));}vec4 bC;bC=lights12[2];vec4 bD;bD=lights12[3];lowp vec3 bE;if((bC.w==0.0)){bE=vec3(0.0,0.0,0.0);}else{vec3 bF;vec3 bG;if((bC.w==1.0)){bF=bC.xyz;bG=bD.xyz;}else{if((bC.w==2.0)){vec3 bH;bH=(bC.xyz-interpolatedPosition);float bI;bI=sqrt(dot(bH,bH));bF=(bH/bI);bG=(bD.xyz/((12.56637*bI)*bI));}}lowp float bJ;bJ=clamp(dot(a,bF),0.0,1.0);lowp vec3 bK;lowp float bL;float bM;vec3 bN;bN=normalize((q+bF));bM=clamp(dot(q,bN),0.0,1.0);lowp vec3 bO;bO=((a.yzx*bN.zxy)-(a.zxy*bN.yzx));lowp float bP;bP=(clamp(dot(a,bN),0.0,1.0)*t);lowp float bQ;bQ=(t/(dot(bO,bO)+(bP*bP)));bL=min(((bQ*bQ)*0.3183099),65504.0);lowp float bR;bR=(t*t);lowp float bS;bS=(2.0*bc);lowp float bT;bT=(bc+sqrt((bR+(((1.0-bR)*bc)*bc))));lowp float bU;if((bT==0.0)){bU=0.0;}else{bU=(bS/bT);}lowp float bV;bV=(2.0*bJ);lowp float bW;bW=(bJ+sqrt((bR+(((1.0-bR)*bJ)*bJ))));lowp float bX;if((bW==0.0)){bX=0.0;}else{bX=(bV/bW);}bK=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*bM)-6.98316)*bM))));lowp float bY;bY=(bL*(bU*bX));lowp float bZ;bZ=((4.0*bJ)*bc);lowp float ca;if((bZ==0.0)){ca=0.0;}else{ca=(bY/bZ);}bE=((bG*bJ)*((v/3.141593)+(ca*bK)));}vec4 cb;cb=lights34[0];vec4 cc;cc=lights34[1];lowp vec3 cd;if((cb.w==0.0)){cd=vec3(0.0,0.0,0.0);}else{vec3 ce;vec3 cf;if((cb.w==1.0)){ce=cb.xyz;cf=cc.xyz;}else{if((cb.w==2.0)){vec3 cg;cg=(cb.xyz-interpolatedPosition);float ch;ch=sqrt(dot(cg,cg));ce=(cg/ch);cf=(cc.xyz/((12.56637*ch)*ch));}}lowp float ci;ci=clamp(dot(a,ce),0.0,1.0);lowp vec3 cj;lowp float ck;float cl;vec3 cm;cm=normalize((q+ce));cl=clamp(dot(q,cm),0.0,1.0);lowp vec3 cn;cn=((a.yzx*cm.zxy)-(a.zxy*cm.yzx));lowp float co;co=(clamp(dot(a,cm),0.0,1.0)*t);lowp float cp;cp=(t/(dot(cn,cn)+(co*co)));ck=min(((cp*cp)*0.3183099),65504.0);lowp float cq;cq=(t*t);lowp float cr;cr=(2.0*bc);lowp float cs;cs=(bc+sqrt((cq+(((1.0-cq)*bc)*bc))));lowp float ct;if((cs==0.0)){ct=0.0;}else{ct=(cr/cs);}lowp float cu;cu=(2.0*ci);lowp float cv;cv=(ci+sqrt((cq+(((1.0-cq)*ci)*ci))));lowp float cw;if((cv==0.0)){cw=0.0;}else{cw=(cu/cv);}cj=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*cl)-6.98316)*cl))));lowp float cx;cx=(ck*(ct*cw));lowp float cy;cy=((4.0*ci)*bc);lowp float cz;if((cy==0.0)){cz=0.0;}else{cz=(cx/cy);}cd=((cf*ci)*((v/3.141593)+(cz*cj)));}vec4 cA;cA=lights34[2];vec4 cB;cB=lights34[3];lowp vec3 cC;if((cA.w==0.0)){cC=vec3(0.0,0.0,0.0);}else{vec3 cD;vec3 cE;if((cA.w==1.0)){cD=cA.xyz;cE=cB.xyz;}else{if((cA.w==2.0)){vec3 cF;cF=(cA.xyz-interpolatedPosition);float cG;cG=sqrt(dot(cF,cF));cD=(cF/cG);cE=(cB.xyz/((12.56637*cG)*cG));}}lowp float cH;cH=clamp(dot(a,cD),0.0,1.0);lowp vec3 cI;lowp float cJ;float cK;vec3 cL;cL=normalize((q+cD));cK=clamp(dot(q,cL),0.0,1.0);lowp vec3 cM;cM=((a.yzx*cL.zxy)-(a.zxy*cL.yzx));lowp float cN;cN=(clamp(dot(a,cL),0.0,1.0)*t);lowp float cO;cO=(t/(dot(cM,cM)+(cN*cN)));cJ=min(((cO*cO)*0.3183099),65504.0);lowp float cP;cP=(t*t);lowp float cQ;cQ=(2.0*bc);lowp float cR;cR=(bc+sqrt((cP+(((1.0-cP)*bc)*bc))));lowp float cS;if((cR==0.0)){cS=0.0;}else{cS=(cQ/cR);}lowp float cT;cT=(2.0*cH);lowp float cU;cU=(cH+sqrt((cP+(((1.0-cP)*cH)*cH))));lowp float cV;if((cU==0.0)){cV=0.0;}else{cV=(cT/cU);}cI=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*cK)-6.98316)*cK))));lowp float cW;cW=(cJ*(cS*cV));lowp float cX;cX=((4.0*cH)*bc);lowp float cY;if((cX==0.0)){cY=0.0;}else{cY=(cW/cX);}cC=((cE*cH)*((v/3.141593)+(cY*cI)));}vec4 cZ;cZ=lights56[0];vec4 da;da=lights56[1];lowp vec3 db;if((cZ.w==0.0)){db=vec3(0.0,0.0,0.0);}else{vec3 dc;vec3 dd;if((cZ.w==1.0)){dc=cZ.xyz;dd=da.xyz;}else{if((cZ.w==2.0)){vec3 de;de=(cZ.xyz-interpolatedPosition);float df;df=sqrt(dot(de,de));dc=(de/df);dd=(da.xyz/((12.56637*df)*df));}}lowp float dg;dg=clamp(dot(a,dc),0.0,1.0);lowp vec3 dh;lowp float di;float dj;vec3 dk;dk=normalize((q+dc));dj=clamp(dot(q,dk),0.0,1.0);lowp vec3 dl;dl=((a.yzx*dk.zxy)-(a.zxy*dk.yzx));lowp float dm;dm=(clamp(dot(a,dk),0.0,1.0)*t);lowp float dn;dn=(t/(dot(dl,dl)+(dm*dm)));di=min(((dn*dn)*0.3183099),65504.0);lowp float do_;do_=(t*t);lowp float dp;dp=(2.0*bc);lowp float dq;dq=(bc+sqrt((do_+(((1.0-do_)*bc)*bc))));lowp float dr;if((dq==0.0)){dr=0.0;}else{dr=(dp/dq);}lowp float ds;ds=(2.0*dg);lowp float dt;dt=(dg+sqrt((do_+(((1.0-do_)*dg)*dg))));lowp float du;if((dt==0.0)){du=0.0;}else{du=(ds/dt);}dh=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*dj)-6.98316)*dj))));lowp float dv;dv=(di*(dr*du));lowp float dw;dw=((4.0*dg)*bc);lowp float dx;if((dw==0.0)){dx=0.0;}else{dx=(dv/dw);}db=((dd*dg)*((v/3.141593)+(dx*dh)));}vec4 dy;dy=lights56[2];vec4 dz;dz=lights56[3];lowp vec3 dA;if((dy.w==0.0)){dA=vec3(0.0,0.0,0.0);}else{vec3 dB;vec3 dC;if((dy.w==1.0)){dB=dy.xyz;dC=dz.xyz;}else{if((dy.w==2.0)){vec3 dD;dD=(dy.xyz-interpolatedPosition);float dE;dE=sqrt(dot(dD,dD));dB=(dD/dE);dC=(dz.xyz/((12.56637*dE)*dE));}}lowp float dF;dF=clamp(dot(a,dB),0.0,1.0);lowp vec3 dG;lowp float dH;float dI;vec3 dJ;dJ=normalize((q+dB));dI=clamp(dot(q,dJ),0.0,1.0);lowp vec3 dK;dK=((a.yzx*dJ.zxy)-(a.zxy*dJ.yzx));lowp float dL;dL=(clamp(dot(a,dJ),0.0,1.0)*t);lowp float dM;dM=(t/(dot(dK,dK)+(dL*dL)));dH=min(((dM*dM)*0.3183099),65504.0);lowp float dN;dN=(t*t);lowp float dO;dO=(2.0*bc);lowp float dP;dP=(bc+sqrt((dN+(((1.0-dN)*bc)*bc))));lowp float dQ;if((dP==0.0)){dQ=0.0;}else{dQ=(dO/dP);}lowp float dR;dR=(2.0*dF);lowp float dS;dS=(dF+sqrt((dN+(((1.0-dN)*dF)*dF))));lowp float dT;if((dS==0.0)){dT=0.0;}else{dT=(dR/dS);}dG=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*dI)-6.98316)*dI))));lowp float dU;dU=(dH*(dQ*dT));lowp float dV;dV=((4.0*dF)*bc);lowp float dW;if((dV==0.0)){dW=0.0;}else{dW=(dU/dV);}dA=((dC*dF)*((v/3.141593)+(dW*dG)));}vec4 dX;dX=lights78[0];vec4 dY;dY=lights78[1];lowp vec3 dZ;if((dX.w==0.0)){dZ=vec3(0.0,0.0,0.0);}else{vec3 ea;vec3 eb;if((dX.w==1.0)){ea=dX.xyz;eb=dY.xyz;}else{if((dX.w==2.0)){vec3 ec;ec=(dX.xyz-interpolatedPosition);float ed;ed=sqrt(dot(ec,ec));ea=(ec/ed);eb=(dY.xyz/((12.56637*ed)*ed));}}lowp float ee;ee=clamp(dot(a,ea),0.0,1.0);lowp vec3 ef;lowp float eg;float eh;vec3 ei;ei=normalize((q+ea));eh=clamp(dot(q,ei),0.0,1.0);lowp vec3 ej;ej=((a.yzx*ei.zxy)-(a.zxy*ei.yzx));lowp float ek;ek=(clamp(dot(a,ei),0.0,1.0)*t);lowp float el;el=(t/(dot(ej,ej)+(ek*ek)));eg=min(((el*el)*0.3183099),65504.0);lowp float em;em=(t*t);lowp float en;en=(2.0*bc);lowp float eo;eo=(bc+sqrt((em+(((1.0-em)*bc)*bc))));lowp float ep;if((eo==0.0)){ep=0.0;}else{ep=(en/eo);}lowp float eq;eq=(2.0*ee);lowp float er;er=(ee+sqrt((em+(((1.0-em)*ee)*ee))));lowp float es;if((er==0.0)){es=0.0;}else{es=(eq/er);}ef=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*eh)-6.98316)*eh))));lowp float et;et=(eg*(ep*es));lowp float eu;eu=((4.0*ee)*bc);lowp float ev;if((eu==0.0)){ev=0.0;}else{ev=(et/eu);}dZ=((eb*ee)*((v/3.141593)+(ev*ef)));}vec4 ew;ew=lights78[2];vec4 ex;ex=lights78[3];lowp vec3 ey;if((ew.w==0.0)){ey=vec3(0.0,0.0,0.0);}else{vec3 ez;vec3 eA;if((ew.w==1.0)){ez=ew.xyz;eA=ex.xyz;}else{if((ew.w==2.0)){vec3 eB;eB=(ew.xyz-interpolatedPosition);float eC;eC=sqrt(dot(eB,eB));ez=(eB/eC);eA=(ex.xyz/((12.56637*eC)*eC));}}lowp float eD;eD=clamp(dot(a,ez),0.0,1.0);lowp vec3 eE;lowp float eF;float eG;vec3 eH;eH=normalize((q+ez));eG=clamp(dot(q,eH),0.0,1.0);lowp vec3 eI;eI=((a.yzx*eH.zxy)-(a.zxy*eH.yzx));lowp float eJ;eJ=(clamp(dot(a,eH),0.0,1.0)*t);lowp float eK;eK=(t/(dot(eI,eI)+(eJ*eJ)));eF=min(((eK*eK)*0.3183099),65504.0);lowp float eL;eL=(t*t);lowp float eM;eM=(2.0*bc);lowp float eN;eN=(bc+sqrt((eL+(((1.0-eL)*bc)*bc))));lowp float eO;if((eN==0.0)){eO=0.0;}else{eO=(eM/eN);}lowp float eP;eP=(2.0*eD);lowp float eQ;eQ=(eD+sqrt((eL+(((1.0-eL)*eD)*eD))));lowp float eR;if((eQ==0.0)){eR=0.0;}else{eR=(eP/eQ);}eE=(w+((vec3(1.0,1.0,1.0)-w)*exp2((((-5.55473*eG)-6.98316)*eG))));lowp float eS;eS=(eF*(eO*eR));lowp float eT;eT=((4.0*eD)*bc);lowp float eU;if((eT==0.0)){eU=0.0;}else{eU=(eS/eT);}ey=((eA*eD)*((v/3.141593)+(eU*eE)));}s=(((x+bf)+(bE+cd))+((cC+db)+((dA+dZ)+ey)));vec3 eV;eV=sceneProperties[2].xyz;lowp float eW;eW=(s.x/eV.x);lowp float eX;eX=(s.y/eV.y);lowp float eY;eY=(s.z/eV.z);lowp float eZ;eZ=(((0.2126*eW)+(0.7152*eX))+(0.0722*eY));float fa;fa=sceneProperties[2].w;lowp float fb;fb=(((eZ*(1.0+(eZ/(fa*fa))))/(1.0+eZ))/eZ);lowp float fc;fc=(eW*fb);mediump float fd;if((fc<=0.0031308)){fd=(12.92*fc);}else{fd=((1.055*pow(fc,0.4166667))-0.055);}lowp float fe;fe=(eX*fb);mediump float ff;if((fe<=0.0031308)){ff=(12.92*fe);}else{ff=((1.055*pow(fe,0.4166667))-0.055);}lowp float fg;fg=(eY*fb);mediump float fh;if((fg<=0.0031308)){fh=(12.92*fg);}else{fh=((1.055*pow(fg,0.4166667))-0.055);}mediump vec4 fi;fi.w=1.0;fi.x=fd;fi.y=ff;fi.z=fh;gl_FragColor=fi;}
    |]
